diff -urN sourceold/scripts/jmgUtility.cpp source/scripts/jmgUtility.cpp
--- sourceold/scripts/jmgUtility.cpp	2019-08-20 10:11:06.814000100 +1000
+++ source/scripts/jmgUtility.cpp	2020-09-10 09:08:27.970221800 +1000
@@ -12,8 +12,8 @@
 #include "engine_player.h"
 #include "DefinitionMgrClass.h"
 #include "AudibleSoundDefinitionClass.h"
+#include "TranslateDBClass.h"
 bool JmgUtility::hasStatedDeathMessage[128] = {false};
-
 void JMG_Utility_Check_If_Script_Is_In_Library::Created(GameObject *obj)
 {
 	Commands->Start_Timer(obj,this,0.1f,1);
@@ -1450,7 +1450,29 @@
 }
 void JMG_Utility_Dynamic_Clock_Object::Created(GameObject *obj)
 {
+	for (int x = 0;x < 128;x++)
+		animSynced[x] = false;
 	DynamicClockSystemControl += obj;
+	Commands->Start_Timer(obj,this,1.0f,1);
+}
+void JMG_Utility_Dynamic_Clock_Object::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1) 
+	{
+		for (int x = 1;x < 128;x++)
+		{
+			GameObject *player = Get_GameObj(x);
+			if (player && animSynced[x] < 3)
+			{
+				animSynced[x]++;
+				if (animSynced[x] == 3)
+					Set_Subobject_Animation_Player(player,obj,"s_ecwClock.a_ecwClock",false,0,Get_Animation_Frame(obj),Get_Animation_Frame(obj),false);
+			}
+			if (!player && animSynced[x])
+				animSynced[x] = 0;
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
 }
 void JMG_Utility_Dynamic_Clock_Object::Destroyed(GameObject *obj)
 {
@@ -2251,7 +2273,7 @@
 	sprintf(originalSkin,"");
 	sprintf(originalArmor,"");
 	sprintf(originalModel,"");
-	for (SLNode<ScriptZoneGameObj>* node = GameObjManager::ScriptZoneGameObjList.Head(); node; node = node->Next())
+	for (SLNode<ScriptZoneGameObj>* node = GameObjManager::ScriptZoneGameObjList.Head();node;node = node->Next())
 	{
 		GameObject *zone = (GameObject *)node->Data();
 		if (Is_Script_Attached(zone,"JMG_Utility_Swimming_Zone") && IsInsideZone(zone,obj))
@@ -3170,6 +3192,10 @@
 		node = aggressiveAttackSpotSystemControl->addNode(obj,Get_Int_Parameter("GroupId"),Get_Vector3_Parameter("AttackOffset"));
 	}
 }
+void JMG_Utility_AI_Aggressive_Attack_Spot_Point::Killed(GameObject *obj,GameObject *killer)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_AI_Aggressive_Attack_Spot_Point::Destroyed(GameObject *obj)
 {
 	if (!The_Game()->Is_Game_Over() && node)
@@ -3692,6 +3718,7 @@
 	controllerPlaced = true;
 	for (int x = 0;x < 128;x++)
 		playerNames[x][0] = '\0';
+	BasicObjectiveSystem.controllerId = Commands->Get_ID(obj);
 	BasicObjectiveSystem = NewObjectiveSystem(Get_Int_Parameter("Team"),Get_Int_Parameter("ShowMarkersOnRadar") ? true : false,Get_Parameter("PrimaryObjectiveModel"),Get_Parameter("SecondaryObjectiveModel"),Get_Parameter("TertiaryObjectiveModel"));
 	Commands->Start_Timer(obj,this,1.0f,1);
 }
@@ -3763,11 +3790,13 @@
 				Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Enter ERROR: Could not find objective marker object!");
 				return;
 			}
+			bool added = false;
 			if (ObjectiveMarker)
-				BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"),ObjectiveMarker);
+				added = BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"),ObjectiveMarker);
 			else
-				BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"));
-			JmgUtility::SetHUDHelpText(Get_Int_Parameter("NewObjectiveStringID"),BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority")));
+				added = BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"));
+			if (added)
+				JmgUtility::SetHUDHelpText(Get_Int_Parameter("NewObjectiveStringID"),BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority")));
 		}
 	}
 }
@@ -3794,11 +3823,13 @@
 			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Pickup ERROR: Could not find objective marker object!");
 			return;
 		}
+		bool added = false;
 		if (ObjectiveMarker)
-			BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"),ObjectiveMarker);
+			added = BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"),ObjectiveMarker);
 		else
-			BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"));
-		JmgUtility::SetHUDHelpText(Get_Int_Parameter("NewObjectiveStringID"),BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority")));
+			added = BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"));
+		if (added)
+			JmgUtility::SetHUDHelpText(Get_Int_Parameter("NewObjectiveStringID"),BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority")));
 	}
 }
 void JMG_Utility_Objective_System_Objective_Update_Killed::Killed(GameObject *obj, GameObject *damager)
@@ -3822,11 +3853,13 @@
 		Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Killed ERROR: Could not find objective marker object!");
 		return;
 	}
+	bool added = false;
 	if (ObjectiveMarker)
-		BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"),ObjectiveMarker);
+		added = BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"),ObjectiveMarker);
 	else
-		BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"));
-	JmgUtility::SetHUDHelpText(Get_Int_Parameter("NewObjectiveStringID"),BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority")));
+		added = BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"));
+	if (added)
+		JmgUtility::SetHUDHelpText(Get_Int_Parameter("NewObjectiveStringID"),BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority")));
 }
 void JMG_Utility_Objective_System_Objective_Update_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
@@ -3849,11 +3882,13 @@
 			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Custom ERROR: Could not find objective marker object!");
 			return;
 		}
+		bool added = false;
 		if (ObjectiveMarker)
-			BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"),ObjectiveMarker);
+			added = BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"),ObjectiveMarker);
 		else
-			BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"));
-		JmgUtility::SetHUDHelpText(Get_Int_Parameter("NewObjectiveStringID"),BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority")));
+			added = BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"));
+		if (added)
+			JmgUtility::SetHUDHelpText(Get_Int_Parameter("NewObjectiveStringID"),BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority")));
 	}
 }
 void JMG_Utility_Destroyed_Apply_Damage::Destroyed(GameObject *obj)
@@ -3964,6 +3999,8 @@
 	armorPerPlayer = Get_Float_Parameter("ArmorPerPlayer");
 	damageDelay = Get_Float_Parameter("DamageDelay");
 	rate = Get_Float_Parameter("Rate");
+	scaleHealthPerHeal = Get_Float_Parameter("ScaleHealthPerHeal")*0.00001f;
+	scaleArmorPerHeal = Get_Float_Parameter("ScaleArmorPerHeal")*0.00001f;
 	enabled = true;
 	Commands->Start_Timer(obj,this,rate,1);
 }
@@ -3977,24 +4014,31 @@
 			float maxHealth = Commands->Get_Max_Health(obj);
 			float armor = Commands->Get_Shield_Strength(obj);
 			float maxArmor = Commands->Get_Max_Shield_Strength(obj);
-			if (regenArmor == -1 && armor < maxArmor)
+			if (regenArmor == -1 && armor < maxArmor && armorAmount+armorPerPlayer)
 			{
 				Commands->Set_Shield_Strength(obj,armor+armorAmount+armorPerPlayer*Get_Player_Count());
 				if (Commands->Get_Shield_Strength(obj) > maxArmor)
 					Commands->Set_Shield_Strength(obj,maxArmor);
 			}
-			else if (regenHealth && health < maxHealth)
+			else if (regenHealth && health < maxHealth && healthAmount+healthPerPlayer)
 			{
 				Commands->Set_Health(obj,health+healthAmount+healthPerPlayer*Get_Player_Count());
 				if (Commands->Get_Health(obj) > maxHealth)
 					Commands->Set_Health(obj,maxHealth);
 			}
-			else if (regenArmor && armor < maxArmor)
+			else if (regenArmor && armor < maxArmor && armorAmount+armorPerPlayer)
 			{
 				Commands->Set_Shield_Strength(obj,armor+armorAmount+armorPerPlayer*Get_Player_Count());
 				if (Commands->Get_Shield_Strength(obj) > maxArmor)
 					Commands->Set_Shield_Strength(obj,maxArmor);
 			}
+			healthAmount = ScaleValue(healthAmount,scaleHealthPerHeal);
+			armorAmount = ScaleValue(armorAmount,scaleArmorPerHeal);
+			if ((!regenHealth || healthAmount == 0.0f) && (!regenArmor || armorAmount == 0.0f))
+			{
+				Destroy_Script();
+				return;
+			}
 		}
 		Commands->Start_Timer(obj,this,rate,1);
 	}
@@ -4011,6 +4055,15 @@
 	Stop_Timer2(obj,this,2);
 	Commands->Start_Timer(obj,this,damageDelay,2);
 }
+float JMG_Utility_Regen_HitPoints::ScaleValue(float value,float scale)
+{
+	if (scale == 0.0f || value == 0.0f)
+		return value;
+	value += scale;
+	if (value < 0.0f)
+		return 0.0f;
+	return value;
+}
 void JMG_Utility_Toggle_Flight_On_Delay::Created(GameObject *obj)
 {
 	Commands->Start_Timer(obj,this,Get_Float_Parameter("Delay"),1);
@@ -4749,6 +4802,8 @@
 		}
 		if (nearest)
 			Commands->Destroy_Object(nearest);
+		if (Get_Int_Parameter("TriggerOnce"))
+			Destroy_Script();
 	}
 }
 void JMG_Utility_Zone_Set_Spawner::Entered(GameObject *obj,GameObject *enter)
@@ -5098,11 +5153,13 @@
 				Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Create ERROR: Could not find objective marker object!");
 				return;
 			}
+			bool added = false;
 			if (ObjectiveMarker)
-				BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"),ObjectiveMarker);
+				added = BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"),ObjectiveMarker);
 			else
-				BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"));
-			JmgUtility::SetHUDHelpText(Get_Int_Parameter("NewObjectiveStringID"),BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority")));
+				added = BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("NewObjectiveID"),(NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority"),NewObjectiveSystem::Pending,Get_Int_Parameter("NewObjectiveStringID"),"",Get_Int_Parameter("NewObjectiveStringID"));
+			if (added)
+				JmgUtility::SetHUDHelpText(Get_Int_Parameter("NewObjectiveStringID"),BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)Get_Int_Parameter("NewObjectivePriority")));
 		}
 	}
 }
@@ -7448,6 +7505,10 @@
 	Commands->Set_Player_Type(obj,Commands->Get_Player_Type(poker));
 	Commands->Enable_HUD_Pokable_Indicator(obj,false);
 }
+void JMG_Utility_AI_Follow_Player_On_Poke::Killed(GameObject *obj, GameObject *killer)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_AI_Follow_Player_On_Poke::Destroyed(GameObject *obj)
 {
 	if (detached)
@@ -10753,7 +10814,7 @@
 	originalWidthScale = 0.0f;
 	drownDamageRate = drownDamageRate;
 	weaponSwitchForward = true;
-	for (SLNode<ScriptZoneGameObj>* node = GameObjManager::ScriptZoneGameObjList.Head(); node; node = node->Next())
+	for (SLNode<ScriptZoneGameObj> *node = GameObjManager::ScriptZoneGameObjList.Head();node;node = node->Next())
 	{
 		GameObject *zone = (GameObject *)node->Data();
 		if (Is_Script_Attached(zone,"JMG_Utility_Swimming_Zone") && IsInsideZone(zone,obj))
@@ -11143,8 +11204,6 @@
 }
 void JMG_Utility_Killed_Send_Custom_From_Killer::Killed(GameObject *obj,GameObject *killer)
 {
-	if (!Commands->Is_A_Star(killer))
-		return;
 	int id = Get_Int_Parameter("ID");
 	GameObject *object = id ? (id == -1 ? killer : Commands->Find_Object(id)) : obj;
 	Commands->Send_Custom_Event(killer,object,Get_Int_Parameter("Custom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
@@ -11608,6 +11667,8 @@
 }
 float JMG_Utility_Base_Defense_Simple::GetPriority(GameObject *seen)
 {
+	if (!seen)
+		return 0;
 	if (seen->As_VehicleGameObj())
 		switch (Get_Vehicle_Mode(seen))
 		{
@@ -11980,6 +12041,7 @@
 			else if (useLowAngleTargetAboveHeight && Commands->Get_Position(obj).Z+useLowAngleTargetAboveHeight < Commands->Get_Position(seen).Z)
 				useHighAngle = false;
 			double height = enemyPos.Z-myPos.Z,angle;
+			myPos.Z = enemyPos.Z = 0.0f;
 			if (!CalculateAngle(&angle,Commands->Get_Distance(enemyPos,myPos),height,useHighAngle))
 			{
 				Commands->Start_Timer(obj,this,0.01f,1);
